/*
 * fetadd_client.c - client program for fetadd
 *
 * This program is adopted from Richard Stevens date ONC RPC example
 */

#include	<stdio.h>
#include	<rpc/rpc.h>	/* standard RPC include file */
#include	"fetadd.h"	/* this file is generated by rpcgen */

void testCreate(char *Variable, CLIENT *clnt) {
  Identifier RPCarg ;
  initializeResult *RPCres ;
  fprintf(stdout, "Calling create with \"%s\"\n", Variable) ;
  RPCarg = Variable ;
  RPCres = create_1(&RPCarg, clnt) ;
  switch(*RPCres) {
  case INIT_OK:
    fputs("Result: Success!\n", stdout) ;
    break ;
  case INIT_ALREADYDEFINED:
    fputs("Result: Failure -- variable already defined.\n", stdout) ;
    break ;
  case INIT_IMPROPERSTRING:
    fputs("Result: Failure -- improper variable.\n", stdout) ;
    break ;
  }
}

void testIncrement(char *Variable, int incrmnt, CLIENT *clnt) {
  incrementArg RPCarg ;
  incrementResult *RPCres ;
  fprintf(stdout, "Calling increment with \"%s\" and %d\n",
	  Variable, incrmnt ) ;
  RPCarg.incrVariable = Variable ;
  RPCarg.incrValue = incrmnt ;
  RPCres = increment_1(&RPCarg, clnt) ;
  switch((int)RPCres->incrSelector) {
  case INCR_OK:
    fprintf(stdout, "Result: Success -> %d!\n",
	    RPCres->incrementResult_u.incrValue) ;
    break ;
  case INCR_NOTDEFINED:
    fputs("Result: Failure -- variable not defined.\n", stdout) ;
    break ;
  case INCR_IMPROPERSTRING:
    fputs("Result: Failure -- improper variable.\n", stdout) ;
    break ;
  }
}

main(argc, argv)
int	argc;
char	*argv[];
{
	CLIENT		*cl;		/* RPC handle */
	char		*server;

	if (argc != 2) {
		fprintf(stderr, "usage: %s hostname\n", argv[0]);
		exit(1);
	}
	server = argv[1];

	/*
	 * Create the client "handle."
	 */

	if ( (cl = clnt_create(server, CSCI333FETADD_PROG,
			       FETADD_VERS, "udp")) == NULL) {
		/*
		 * Couldn't establish connection with server.
		 */

		clnt_pcreateerror(server);
		exit(2);
	}

	testCreate("abcd", cl) ;
	testCreate("abcde", cl) ;
	testIncrement("abcd", 100, cl) ;

	clnt_destroy(cl);		/* done with the handle */
	exit(0);
}
